%global momorel 10
%global _default_patch_fuzz 2
%global geckover 1.9.1

%global gcc_release 4.3
%global gcc_version %{gcc_release}.3
%global gcc_src_version %{gcc_release}.2

%define DATE 20090501

%global pkg_suffix %{nil}
%global bin_suffix %{nil}

%global debug_package %{nil}

Summary: Various compilers (C, C++, Objective-C, Java, ...)
Name: gcc%{pkg_suffix}

%define _unpackaged_files_terminate_build 0
%define multilib_64_archs sparc64 ppc64 s390x x86_64
%define include_gappletviewer 1
%define bootstrap_gcj 0

%ifarch %{ix86} x86_64 ia64 ppc s390 alpha
###%define build_ada 1
%define build_ada 0
%else
%define build_ada 0
%endif
%define build_java 1

%ifarch s390x
%define multilib_32_arch s390
%endif
%ifarch sparc64
%define multilib_32_arch sparc
%endif
%ifarch ppc64
%define multilib_32_arch ppc
%endif
%ifarch x86_64
%define multilib_32_arch i386
%endif

### include local configuration
%{?include_specopt}

### default configurations
#  If you'd like to change these configurations, please copy them to
# ~/rpm/specopt/gcc%%{pkg_suffix}.specopt and edit it.

%{?!do_test: %global do_test 0}
%{?!build_test: %global build_test 0}

Version: %{gcc_version}
Release: %{momorel}m%{?dist}
License: GPLv3+ and "GPLv2+ with exceptions"
Group: Development/Languages
Source0: ftp://gcc.gnu.org/pub/gcc/releases/gcc-%{gcc_src_version}/gcc-%{gcc_src_version}.tar.bz2
# Source0: ftp://gcc.gnu.org/pub/gcc/snapshots/%{gcc_release}-%{DATE}/gcc-%{gcc_release}-%{DATE}.tar.bz2
NoSource: 0
Source1: libgcc_post_upgrade.c
Source2: README.libgcjwebplugin.so
Source3: protoize.1
Source100: eclipse-ecj.jar
# momonga's source
%if "%{bin_suffix}" == ""
Source8000: c89.in
Source8001: c99.in
%endif

# fedora patches
Patch1: gcc43-build-id.patch
Patch2: gcc43-c++-builtin-redecl.patch
Patch3: gcc43-ia64-libunwind.patch
Patch4: gcc43-java-nomulti.patch
Patch5: gcc43-ppc32-retaddr.patch
Patch6: gcc43-ppc64-ia64-GNU-stack.patch
Patch7: gcc43-pr27898.patch
Patch8: gcc43-pr32139.patch
Patch9: gcc43-pr33763.patch
Patch10: gcc43-rh330771.patch
Patch11: gcc43-rh341221.patch
Patch12: gcc43-java-debug-iface-type.patch
Patch13: gcc43-i386-libgomp.patch
Patch14: gcc43-rh251682.patch
Patch15: gcc43-sparc-config-detection.patch
Patch16: gcc43-libgomp-omp_h-multilib.patch
Patch17: gcc43-x86_64-va_start.patch
Patch18: gcc43-pr37189.patch
Patch19: gcc43-altivec-tests.patch
Patch20: gcc43-libtool-no-rpath.patch
Patch21: gcc43-pr36741-revert.patch
Patch22: gcc43-pr34037.patch
Patch23: gcc43-pr37738.patch
Patch24: gcc43-pr29609.patch
Patch25: gcc43-aes.patch
Patch26: gcc43-pr29609-2.patch
Patch27: gcc43-pr29609-3.patch
Patch28: gcc43-pr37870.patch
Patch29: gcc43-pr37858.patch
Patch30: gcc43-pr37879.patch
Patch31: gcc43-pr37924.patch

# upstream patches
# svn diff -r XXXXXX:YYYYYY svn://gcc.gnu.org/svn/gcc/branches/redhat/gcc-4_3-branch/
Patch1000: gcc-4.3.2-rh-r139752.patch.bz2
Patch1001: gcc-4.3.2-rh-r140029.patch.bz2
Patch1002: gcc-4.3.2-rh-r140410.patch.bz2
Patch1003: gcc-4.3.2-rh-r140961.patch.bz2
Patch1004: gcc-4.3.2-rh-r141601.patch.bz2
# svn diff -r XXXXXX:YYYYYY svn://gcc.gnu.org/svn/gcc/branches/gcc-4_3-branch/
# edit something...
Patch2000: gcc-4.3.2-r141912.patch.bz2
Patch2001: gcc-4.3.2-r142899.patch.bz2
Patch2002: gcc-4.3.3-r144116.patch.bz2
Patch2003: gcc-4.3.3-r144971.patch.bz2
Patch2004: gcc-4.3.3-r145576.patch.bz2
Patch2005: gcc-4.3.3-r147026.patch.bz2

# momonga's patches
%if "%{bin_suffix}" != ""
Patch8000: gcc43-textdomain.patch
Patch8001: gcc43-rename-info.patch
Patch8002: gcc43-fix-gcj.patch
%endif

Patch9000: gcc-4.3.3-xulrunner191.patch

URL: http://gcc.gnu.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
# Need binutils with -pie support >= 2.14.90.0.4-4
# Need binutils which can omit dot symbols and overlap .opd on ppc64 >= 2.15.91.0.2-4
# Need binutils which handle -msecure-plt on ppc >= 2.16.91.0.2-2
# Need binutils which support .weakref >= 2.16.91.0.3-1
# Need binutils which support DT_GNU_HASH >= 2.17.50.0.31
# Need binutils which support --build-id >= 2.17.50.0.17-3
BuildRequires: binutils >= 2.17.50.0.18
BuildRequires: zlib-devel, gettext, dejagnu, bison, flex, texinfo, sharutils
%if %{build_java}
BuildRequires: /usr/share/java/eclipse-ecj.jar
BuildRequires: libgcj
%endif
# Make sure pthread.h doesn't contain __thread tokens
# Need glibc support DT_GNU_HASH >= 2.5-1m
BuildRequires: glibc-devel >= 2.5-1m
# Make sure glibc supports stack protector
BuildRequires: glibc-devel >= 2.3.90-3m
# Make sure pthread.h doesn't contain __thread tokens
# Make sure glibc supports stack protector
BuildRequires: glibc-devel >= 2.3.90-3m
BuildRequires: elfutils-devel >= 0.72
%ifarch ppc ppc64 s390 s390x sparc sparcv9 alpha
# Make sure glibc supports TFmode long double
BuildRequires: glibc >= 2.3.90-3m
%endif
%ifarch %{multilib_64_archs} sparc ppc
# Ensure glibc{,-devel} is installed for both multilib arches
BuildRequires: /lib/libc.so.6 /usr/lib/libc.so /lib64/libc.so.6 /usr/lib64/libc.so
%endif
%if %{build_ada}
# Ada requires Ada to build
BuildRequires: gcc-gnat >= 3.1, libgnat >= 3.1
%endif
%ifarch ia64
BuildRequires: libunwind >= 0.98
%endif
%if %{do_test}
# testsuite requires autogen
BuildRequires: autogen
%endif
Requires: cpp%{pkg_suffix} >= %{version}-%{release}
# Need .eh_frame ld optimizations
# Need proper visibility support
# Need -pie support
# Need --as-needed/--no-as-needed support
# On ppc64, need omit dot symbols support and --non-overlapping-opd
# Need binutils that owns /usr/bin/c++filt
# Need binutils that support .weakref
Requires: binutils >= 2.16.91.0.3-1
# Make sure gdb will understand DW_FORM_strp
Conflicts: gdb < 5.1-2
Requires: glibc-devel >= 2.2.90-12
Requires: libgcc%{pkg_suffix} >= %{version}-%{release}
Requires: libgomp%{pkg_suffix} >= %{version}-%{release}
BuildRequires: momonga-rpmmacros >= 20090121-1m
%if !%{build_ada}
Obsoletes: gcc-gnat < %{version}-%{release}
Obsoletes: libgnat < %{version}-%{release}
%endif
%ifarch sparc sparc64
Obsoletes: egcs64
%endif
#Obsoletes: gcc%{pkg_suffix}
#Provides: gcc%{pkg_suffix} = %{version}-%{release}
Requires(post): info coreutils 
Requires(preun): info
Requires(postun): coreutils
AutoReq: true

# On ARM EABI systems, we do want -gnueabi to be part of the
# target triple.
%ifnarch %{arm}
%define _gnu %{nil}
%endif
%ifarch sparc
%define gcc_target_platform sparc64-%{_vendor}-%{_target_os}
%endif
%ifarch ppc
%define gcc_target_platform ppc64-%{_vendor}-%{_target_os}
%endif
%ifnarch sparc ppc
%define gcc_target_platform %{_target_platform}
%endif

%description
The gcc package contains the GNU Compiler Collection version %{gcc_release}.
You'll need this package in order to compile C code.
#'

%package -n libgcc%{pkg_suffix}
Summary: GCC version %{gcc_release} shared support library
Group: System Environment/Libraries
Autoreq: false
Provides: /usr/sbin/libgcc_post_upgrade
#Provides: libgcc = %{version}-%{release}
Obsoletes: libgcc <= 4.1.2

%description -n libgcc%{pkg_suffix}
This package contains GCC shared support library which is needed
e.g. for exception handling support.

%package c++
Summary: C++ support for GCC
Group: Development/Languages
Requires: %{name} = %{version}-%{release}
Requires: libstdc++%{pkg_suffix} = %{version}-%{release}
Requires: libstdc++%{pkg_suffix}-devel = %{version}-%{release}
#Obsoletes: gcc%{pkg_suffix}-c++
#Provides: gcc%{pkg_suffix}-c++ = %{version}-%{release}
Requires(post): coreutils
Requires(postun): coreutils
Autoreq: true

%description c++
This package adds C++ support to the GNU Compiler Collection.
It includes support for most of the current C++ specification,
including templates and exception handling.

%package -n libstdc++%{pkg_suffix}
Summary: GNU Standard C++ Library
Group: System Environment/Libraries
Autoreq: true
#Provides: libstdc++ = %{version}-%{release}
Obsoletes: libstdc++ <= 4.1.2

%description -n libstdc++%{pkg_suffix}
The libstdc++ package contains a rewritten standard compliant GCC Standard
C++ Library.

%package -n libstdc++%{pkg_suffix}-devel
Summary: Header files and libraries for C++ development
Group: Development/Libraries
Requires: libstdc++%{pkg_suffix} = %{version}-%{release}
Autoreq: true

%description -n libstdc++%{pkg_suffix}-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the header files and libraries needed for C++
development. This includes rewritten implementation of STL.

%package objc
Summary: Objective-C support for GCC
Group: Development/Languages
Requires: %{name} = %{version}-%{release}
Requires: libobjc%{pkg_suffix} = %{version}-%{release}
Autoreq: true

%description objc
gcc-objc provides Objective-C support for the GCC.
Mainly used on systems running NeXTSTEP, Objective-C is an
object-oriented derivative of the C language.

%package objc++
Summary: Objective-C++ support for GCC
Group: Development/Languages
Requires: %{name}-c++ = %{version}-%{release}
Requires: %{name}-objc = %{version}-%{release}
Autoreq: true

%description objc++
gcc-objc++ package provides Objective-C++ support for the GCC.

%package -n libobjc%{pkg_suffix}
Summary: Objective-C runtime
Group: System Environment/Libraries
Autoreq: true
Obsoletes: libobjc <= 4.1.2
Obsoletes: libobjc42 <= 4.2.3-0.4

%description -n libobjc%{pkg_suffix}
This package contains Objective-C shared library which is needed to run
Objective-C dynamically linked programs.

%package gfortran
Summary: Fortran 95 support
Group: Development/Languages
Requires: %{name} = %{version}-%{release}
Requires: libgfortran%{pkg_suffix} = %{version}-%{release}
BuildRequires: gmp-devel >= 4.2.4
BuildRequires: mpfr-devel >= 2.3.2
Requires(post): info
Requires(preun): info
Obsoletes: gcc%{pkg_suffix}-g77
Provides: gcc%{pkg_suffix}-g77
#Obsoletes: gcc%{pkg_suffix}-gfortran
#Provides: gcc%{pkg_suffix}-gfortran
Autoreq: true

%description gfortran
The gcc-gfortran package provides support for compiling Fortran 95
programs with the GNU Compiler Collection.

%package -n libgfortran%{pkg_suffix}
Summary: Fortran 95 runtime
Group: System Environment/Libraries
Autoreq: true
Obsoletes: libgfortran <= 4.1.2

%description -n libgfortran%{pkg_suffix}
This package contains Fortran 95 shared library which is needed to run
Fortran 95 dynamically linked programs.

%package -n libgomp%{pkg_suffix}
Summary: GCC OpenMP v3.0 shared support library
Group: System Environment/Libraries
Requires(post): info
Requires(preun): info
#Provides: libgomp = %{version}-%{release}
Obsoletes: libgomp <= 4.1.2
Obsoletes: libgomp42 <= 4.2.3-0.4

%description -n libgomp%{pkg_suffix}
This package contains GCC shared support library which is needed
for OpenMP v3.0 support.

%package -n libmudflap%{pkg_suffix}
Summary: GCC mudflap shared support library
Group: System Environment/Libraries
#Provides: libmudflap = %{version}-%{release}
Obsoletes: libmudflap <= 4.1.2
Obsoletes: libmudflap42 <= 4.2.3-0.4

%description -n libmudflap%{pkg_suffix}
This package contains GCC shared support library which is needed
for mudflap support.

%package -n libmudflap%{pkg_suffix}-devel
Summary: GCC mudflap support
Group: Development/Libraries
Requires: libmudflap%{pkg_suffix} = %{version}-%{release}
Requires: %{name} = %{version}-%{release}
Obsoletes: libmudflap-devel <= 4.1.2

%description -n libmudflap%{pkg_suffix}-devel
This package contains headers and static libraries for building
mudflap-instrumented programs.

To instrument a non-threaded program, add -fmudflap
option to GCC and when linking add -lmudflap, for threaded programs
also add -fmudflapth and -lmudflapth.

%if %{build_java}
%package java
Summary: Java support for GCC
Group: Development/Languages
Requires: %{name} = %{version}-%{release}
Requires: libgcj%{pkg_suffix} >= %{version}
Requires: libgcj%{pkg_suffix}-devel >= %{version}
Requires: zlib-devel
#Obsoletes: gcc%{pkg_suffix}-java
#Provides: gcc%{pkg_suffix}-java
Requires(post): info
Requires(preun): info
Autoreq: true

%description java
This package adds support for compiling Java(tm) programs and
bytecode into native code.

%package -n libgcj%{pkg_suffix}
Summary: Java runtime library for gcc
Group: System Environment/Libraries
Requires: zip >= 2.1
Requires: gtk2 >= 2.4.0
BuildRequires: gtk2-devel >= 2.4.0
Requires: glib2 >= 2.4.0
BuildRequires: glib2-devel >= 2.4.0
Requires: libart_lgpl >= 2.1.0
%if %{build_java}
BuildRequires: xulrunner-devel >= %{geckover}
%endif
BuildRequires: libart_lgpl-devel >= 2.1.0
BuildRequires: alsa-lib-devel
BuildRequires: libXtst-devel
BuildRequires: libXt-devel
BuildRequires: fastjar
Obsoletes: gcc-libgcj
#Obsoletes: libgcj%{pkg_suffix}
#Provides: libgcj%{pkg_suffix}
Autoreq: true
Requires: fastjar
Obsoletes: libgcj <= 4.1.2
#Provides: libgcj = %{version}-%{release}

%description -n libgcj%{pkg_suffix}
The Java(tm) runtime library. You will need this package to run your Java
programs compiled using the Java compiler from GNU Compiler Collection (gcj).

%package -n libgcj%{pkg_suffix}-devel
Summary: Libraries for Java development using GCC
Group: Development/Languages
Requires: zip >= 2.1
Requires: libgcj%{pkg_suffix} = %{version}-%{release}
Requires: zlib-devel
Requires: gawk
# note: gcc is required because of /usr/include/c++
Requires: gcc 
Autoreq: false
Autoprov: false

%description -n libgcj%{pkg_suffix}-devel
The Java(tm) static libraries and C header files. You will need this
package to compile your Java programs using the GCC Java compiler (gcj).

%package -n libgcj%{pkg_suffix}-src
Summary: Java library sources from GCC4 preview
Group: System Environment/Libraries
Requires: libgcj%{pkg_suffix} = %{version}-%{release}
#Obsoletes: libgcj%{pkg_suffix}-src
#Provides: libgcj%{pkg_suffix}-src
Obsoletes: libgcj-src <= 4.1.2
Autoreq: true

%description -n libgcj%{pkg_suffix}-src
The Java(tm) runtime library sources for use in Eclipse.
%endif

%package -n cpp%{pkg_suffix}
Summary: The C Preprocessor.
Group: Development/Languages
Requires(post): info
Requires(preun): info
%ifarch ia64
Obsoletes: gnupro
%endif
Autoreq: true

%description -n cpp%{pkg_suffix}
Cpp is the GNU C-Compatible Compiler Preprocessor.
Cpp is a macro processor which is used automatically
by the C compiler to transform your program before actual
compilation. It is called a macro processor because it allows
you to define macros, abbreviations for longer
constructs.

The C preprocessor provides four separate functionalities: the
inclusion of header files (files of declarations that can be
substituted into your program); macro expansion (you can define macros,
and the C preprocessor will replace the macros with their definitions
throughout the program); conditional compilation (using special
preprocessing directives, you can include or exclude parts of the
program according to various conditions); and line control (if you use
a program to combine or rearrange source files into an intermediate
file which is then compiled, you can use line control to inform the
compiler about where each source line originated).

You should install this package if you are a C programmer and you use
macros.

%package gnat
Summary: Ada 95 support for GCC
Group: Development/Languages
Requires: %{name} = %{version}-%{release}, libgnat%{pkg_suffix} = %{version}-%{release}
Obsoletes: gnat-devel, gcc3-gnat
Requires(post): info
Requires(preun): info
Autoreq: true

%description gnat
GNAT is a GNU Ada 95 front-end to GCC. This package includes development tools,
the documents and Ada 95 compiler.

%package -n libgnat%{pkg_suffix}
Summary: GNU Ada 95 runtime shared libraries
Group: System Environment/Libraries
Obsoletes: libgnat3
Obsoletes: libgnat <= 4.1.2
Autoreq: true

%description -n libgnat%{pkg_suffix}
GNAT is a GNU Ada 95 front-end to GCC. This package includes shared libraries,
which are required to run programs compiled with the GNAT.

%package -n libffi
Summary: GCC ffi shared support library
Group: System Environment/Libraries

%description -n libffi
This package contains GCC shared support library which is needed
for ffi support.

%package -n libffi-devel
Summary: GCC ffi support
Group: Development/Libraries
Requires: libffi-devel = %{version}-%{release}

%description -n libffi-devel
This package contains headers and static libraries for building
ffi-instrumented programs.

%prep
# %setup -q -n gcc-%{gcc_release}-%{DATE}
%setup -q -n gcc-%{gcc_src_version}

# upstream patch
%patch1000 -p0 -E 
%patch1001 -p0 -E 
%patch1002 -p0 -E 
%patch1003 -p0 -E 
%patch1004 -p0 -E 
%patch2000 -p0 -E 
%patch2001 -p0 -E 
%patch2002 -p0 -E 
%patch2003 -p0 -E
%patch2004 -p0 -E
%patch2005 -p0 -E

# fedora's patches
%patch1 -p0 -b .build-id~
%patch2 -p0 -b .c++-builtin-redecl~
%patch3 -p0 -b .ia64-libunwind~
%patch4 -p0 -b .java-nomulti~
%patch5 -p0 -b .ppc32-retaddr~
%patch6 -p0 -b .ppc64-ia64-GNU-stack~
%patch7 -p0 -b .pr27898~
%patch8 -p0 -b .pr32139~
%patch9 -p0 -b .pr33763~
%patch10 -p0 -b .rh330771~
%patch11 -p0 -b .rh341221~
%patch12 -p0 -b .java-debug-iface-type~
%patch13 -p0 -b .i386-libgomp~
%patch14 -p0 -b .rh251682~
%patch15 -p0 -b .sparc-config-detection~
%patch16 -p0 -b .libgomp-omp_h-multilib~
%patch17 -p0 -b .x86_64-va_start~
%patch18 -p0 -b .pr37189~
# %patch19 -p0 -b .altivec-tests~
%patch20 -p0 -b .libtool-no-rpath~
%patch21 -p0 -b .pr36741-revert~
%patch22 -p0 -b .pr34037~
%patch23 -p0 -b .pr37738~
%patch24 -p0 -b .pr29609~
%patch25 -p0 -b .aes~
%patch26 -p0 -b .pr29609-2~
%patch27 -p0 -b .pr29609-3~
# %patch28 -p0 -b .pr37870~
# %patch29 -p0 -b .pr37858~
# %patch30 -p0 -b .pr37879~
# %patch31 -p0 -b .pr37924~

# momonga's patches
%if "%{bin_suffix}" != ""
%patch8000 -p1 -b .textdomain~
%patch8001 -p1 -b .info~
%patch8002 -p1 -b .fixgcj~
%endif

%patch9000 -p1 -b .xulrunner191

sed -i -e 's/4\.3\.4/4.3.3/' gcc/BASE-VER
echo stable > gcc/DEV-PHASE

cp -a libstdc++-v3/config/cpu/i{4,3}86/atomicity.h

# Hack to avoid building multilib libjava
perl -pi -e 's/^all: all-redirect/ifeq (\$(MULTISUBDIR),)\nall: all-redirect\nelse\nall:\n\techo Multilib libjava build disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^install: install-redirect/ifeq (\$(MULTISUBDIR),)\ninstall: install-redirect\nelse\ninstall:\n\techo Multilib libjava install disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^check: check-redirect/ifeq (\$(MULTISUBDIR),)\ncheck: check-redirect\nelse\ncheck:\n\techo Multilib libjava check disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^all: all-recursive/ifeq (\$(MULTISUBDIR),)\nall: all-recursive\nelse\nall:\n\techo Multilib libjava build disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^install: install-recursive/ifeq (\$(MULTISUBDIR),)\ninstall: install-recursive\nelse\ninstall:\n\techo Multilib libjava install disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^check: check-recursive/ifeq (\$(MULTISUBDIR),)\ncheck: check-recursive\nelse\ncheck:\n\techo Multilib libjava check disabled\nendif/' libjava/Makefile.in

./contrib/gcc_update --touch

# To make rpmlint happy (argh), fix up names in ChangeLog entries to valid UTF-8
LC_ALL=C sed -i \
  -e 's/D\(o\|\xf6\)nmez/D\xc3\xb6nmez/' \
  -e 's/\(Av\|\x81\xc1v\|\xc1v\|\xef\xbf\xbdv\?\|\x81\xc3\x81v\|\xc3v\)ila/\xc3\x81vila/' \
  -e 's/Esp\(in\|\x81\xedn\|\xedn\|\xef\xbf\xbdn\?\|\xef\xbf\xbd\xadn\|\x81\xc3\xadn\|\xc3\xef\xbf\xbd\xadn\)dola/Esp\xc3\xadndola/' \
  -e 's/Schl\(u\|\xef\xbf\xbd\|\xfcu\?\|\x81\xfc\|\x81\xc3\xbc\|\xc3\xaf\xc2\xbf\xc2\xbd\|\xef\xbf\xbd\xef\xbf\xbd\xef\xbf\xbd\xc2\xbc\)ter/Schl\xc3\xbcter/' \
  -e 's/Humi\(e\|\xe8\)res/Humi\xc3\xa8res/' \
  -e 's/L\(ow\|\xc3\xaf\xc2\xbf\xc2\xbd\|oew\|\xf6w\)is/L\xc3\xb6wis/' \
  -e 's/G\xfctlein/G\xc3\xbctlein/' \
  -e 's/G\xe1[b]or/G\xc3\xa1bor/' \
  -e 's/L\xf3ki/L\xc3\xb3ki/' \
  -e 's/Fautr\xc3 /Fautr\xc3\xa9 /' \
  -e 's/S\xe9[b]astian/S\xc3\xa9bastian/' \
  -e 's/Th\xef\xbf\xbd[d]ore/Th\xc3\xa9odore/' \
  -e 's/Cors\xc3\xc2\xa9pius/Cors\xc3\xa9pius/' \
  -e 's/K\xfchl/K\xc3\xbchl/' \
  -e 's/R\xf6nnerup/R\xc3\xb6nnerup/' \
  -e 's/L\xf8vset/L\xc3\xb8vset/' \
  -e 's/Ph\x81\xfb\x81\xf4ng-Th\x81\xe5o/Ph\xc3\xbb\xc3\xb4ng-Th\xc3\xa5o/' \
  -e 's/V\x81\xf5/V\xc3\xb5/' \
  -e 's/J\xf6nsson/J\xc3\xb6nsson/' \
  -e 's/V\xef\xbf\xbdis\xef\xbf\xbdnen/V\xc3\xa4is\xc3\xa4nen/' \
  -e 's/J\xef\xbf\xbdrg/J\xc3\xb6rg/' \
  -e 's/M\xef\xbf\xbdsli/M\xc3\xb6sli/' \
  -e 's/R\xe4ty/R\xc3\xa4ty/' \
  -e 's/2003\xc2\xad-/2003-/' \
  -e 's/\xc2\xa0/ /g' \
  -e 's/ \xa0/  /g' \
  -e 's/\xa0 //' \
  `find . -name \*ChangeLog\*`
LC_ALL=C sed -i -e 's/\xa0/ /' gcc/doc/options.texi

%ifarch ppc
if [ -d libstdc++-v3/config/abi/powerpc64-linux-gnu ]; then
  mkdir -p libstdc++-v3/config/abi/powerpc64-linux-gnu/64
  mv libstdc++-v3/config/abi/powerpc64-linux-gnu/{,64/}baseline_symbols.txt
  mv libstdc++-v3/config/abi/powerpc64-linux-gnu/{32/,}baseline_symbols.txt
  rm -rf libstdc++-v3/config/abi/powerpc64-linux-gnu/32
fi
%endif
%ifarch sparc
if [ -d libstdc++-v3/config/abi/sparc64-linux-gnu ]; then
  mkdir -p libstdc++-v3/config/abi/sparc64-linux-gnu/64
  mv libstdc++-v3/config/abi/sparc64-linux-gnu/{,64/}baseline_symbols.txt
  mv libstdc++-v3/config/abi/sparc64-linux-gnu/{32/,}baseline_symbols.txt
  rm -rf libstdc++-v3/config/abi/sparc64-linux-gnu/32
fi
%endif

%build

rm -fr obj-%{gcc_target_platform}
mkdir obj-%{gcc_target_platform}
cd obj-%{gcc_target_platform}

%if %{build_java}
# If we don't have gjavah in $PATH, try to build it with the old gij
mkdir java_hacks
cd java_hacks
if [ ! -x /usr/bin/gjavah ]; then
  cp -a ../../libjava/classpath/tools/external external
  mkdir -p gnu/classpath/tools
  cp -a ../../libjava/classpath/tools/gnu/classpath/tools/{common,javah,getopt} gnu/classpath/tools/
  cp -a ../../libjava/classpath/resource/gnu/classpath/tools/common/Messages.properties gnu/classpath/tools/common
  cd external/asm; for i in `find . -name \*.java`; do gcj --encoding ISO-8859-1 -C $i -I.; done; cd ../..
  for i in `find gnu -name \*.java`; do gcj -C $i -I. -Iexternal/asm/; done
  gcj -findirect-dispatch -O2 -fmain=gnu.classpath.tools.javah.Main -I. -Iexternal/asm/ `find . -name \*.class` -o gjavah.real
  cat > gjavah <<EOF
#!/bin/sh
export CLASSPATH=`pwd`${CLASSPATH:+:$CLASSPATH}
exec `pwd`/gjavah.real "\$@"
EOF
  chmod +x `pwd`/gjavah
fi
cat > ecj1 <<EOF
#!/bin/sh
%if %{bootstrap_gcj}
exec gij -cp %{SOURCE100} org.eclipse.jdt.internal.compiler.batch.GCCMain "\$@"
%else
exec gij -cp /usr/share/java/eclipse-ecj.jar org.eclipse.jdt.internal.compiler.batch.GCCMain "\$@"
%endif
EOF
chmod +x `pwd`/ecj1
export PATH=`pwd`${PATH:+:$PATH}
cd ..
%endif

CC=gcc
OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/\(-Wp,\)\?-D_FORTIFY_SOURCE=[12]//g'`
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-m64//g;s/-m32//g;s/-m31//g'`
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-fstack-protector//g' -e 's/-fno-exceptions//g'`

# OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-funroll-loops//g' -e 's/-fomit-frame-pointer//g' -e 's/-ffast-math//g' `
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-funroll-loops//g' -e 's/-ffast-math//g' `

%ifarch sparc sparc64
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-mcpu=ultrasparc/-mtune=ultrasparc/g;s/-mcpu=v[78]//g'`
%endif
%ifarch sparc64
cat > gcc64 <<"EOF"
#!/bin/sh
exec /usr/bin/gcc -m64 "$@"
EOF
chmod +x gcc64
CC=`pwd`/gcc64
%endif
%ifarch ppc64
if gcc -m64 -xc -S /dev/null -o - > /dev/null 2>&1; then
  cat > gcc64 <<"EOF"
#!/bin/sh
exec /usr/bin/gcc -m64 "$@"
EOF
  chmod +x gcc64
  CC=`pwd`/gcc64
fi
%endif
OPT_FLAGS=`echo "$OPT_FLAGS" | sed -e 's/[[:blank:]]\+/ /g'`
case "$OPT_FLAGS" in
  *-fasynchronous-unwind-tables*)
    sed -i -e 's/-fno-exceptions /-fno-exceptions -fno-asynchronous-unwind-tables/' \
      ../gcc/Makefile.in
    ;;
esac

%if %{build_test}
OPT_FLAGS="-O0"
%endif

(cd ../gcc;autoconf )

CC="$CC" CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" TCFLAGS="$OPT_FLAGS" \
	GCJFLAGS="$OPT_FLAGS" \
	../configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} \
	--with-pkgversion="Momonga Linux %{momonga} %{version}-%{release}" \
	--program-suffix=%{bin_suffix} \
	--enable-shared --enable-threads=posix --enable-checking=release \
	--with-system-zlib --enable-__cxa_atexit \
	--disable-libunwind-exceptions \
	--host=%{gcc_target_platform} --build=%{gcc_target_platform} --target=%{gcc_target_platform} \
%ifarch ia64
        --with-system-libunwind \
%else
        --without-system-libunwind \
%endif
	--enable-languages=c,c++,objc,obj-c++,fortran\
%if %{build_ada}
,ada\
%endif
%if %{build_java}
,java\
%endif
%if !%{build_java}
	--disable-libgcj \
%else
	--enable-java-awt=gtk --disable-dssi --enable-plugin \
        --with-java-home=%{_prefix}/lib/jvm/java-1.5.0-gcj-1.5.0.0/jre \
        --enable-libgcj-multifile \
%if !%{bootstrap_gcj}
	--enable-java-maintainer-mode \
%endif
        --with-ecj-jar=/usr/share/java/eclipse-ecj.jar \
	--disable-libjava-multilib \
%endif
%ifarch ppc ppc64
	--enable-secureplt \
%endif
%ifarch sparc ppc ppc64 s390 s390x alpha
	--with-long-double-128 \
%endif
%ifarch sparc
	 --with-cpu=v7 \
%endif
%ifarch ppc
	--with-cpu=default32 \
%endif
%ifarch %{ix86} x86_64
	--with-cpu=generic \
%endif
%ifarch s390 s390x
	--with-tune=z9-109 \
%endif
%if %{build_test}
        --disable-bootstrap
%endif

%if !%{build_test}
%make BOOT_CFLAGS="$OPT_FLAGS" GCJFLAGS="$OPT_FLAGS" profiledbootstrap
%else
# build without bootstrapping
%make 
%endif

%if %{do_test}
# run the tests.
make %{?_smp_mflags} -k check RUNTESTFLAGS="ALT_CC_UNDER_TEST=gcc ALT_CXX_UNDER_TEST=g++" || :
cd gcc
mv testsuite{,.normal}
make %{?_smp_mflags} -k \
  `sed -n 's/check-ada//;s/^CHECK_TARGETS[[:blank:]]*=[[:blank:]]*//p' Makefile` \
  RUNTESTFLAGS="--target_board=unix/-fstack-protector ALT_CC_UNDER_TEST=gcc ALT_CXX_UNDER_TEST=g++" || :
mv testsuite{,.ssp}
mv testsuite{.normal,}
cd ..
echo ====================TESTING=========================
( ../contrib/test_summary || : ) 2>&1 | sed -n '/^cat.*EOF/,/^EOF/{/^cat.*EOF/d;/^EOF/d;/^LAST_UPDATED:/d;p;}'
echo ====================TESTING END=====================
mkdir testlogs-%{_target_platform}-%{version}-%{release}
for i in `find . -name \*.log | grep -F testsuite/ | grep -v 'config.log\|acats\|ada'`; do
  ln $i testlogs-%{_target_platform}-%{version}-%{release}/ || :
done
for i in `find . -name \*.log | grep -F testsuite.ssp/ | grep -v 'config.log\|acats\|ada'`; do
  ln $i testlogs-%{_target_platform}-%{version}-%{release}/ssp-`basename $i` || :
done
tar cf - testlogs-%{_target_platform}-%{version}-%{release} | bzip2 -9c \
  | uuencode testlogs-%{_target_platform}.tar.bz2 || :
rm -rf testlogs-%{_target_platform}-%{version}-%{release}
%endif

# Make protoize
make -C gcc CC="./xgcc -B ./ -O2" proto

# Make generated man pages even if Pod::Man is not new enough
perl -pi -e 's/head3/head2/' ../contrib/texi2pod.pl
for i in ../gcc/doc/*.texi; do
  cp -a $i $i.orig; sed 's/ftable/table/' $i.orig > $i
done
make -C gcc generated-manpages
for i in ../gcc/doc/*.texi; do mv -f $i.orig $i; done

# Copy various doc files here and there
cd ..
mkdir -p rpm.doc/gfortran rpm.doc/objc
mkdir -p rpm.doc/boehm-gc rpm.doc/libffi rpm.doc/libjava
mkdir -p rpm.doc/changelogs/{gcc/cp,gcc/java,gcc/ada,libstdc++-v3,libobjc,libmudflap,libgomp}
sed -e 's,@VERSION@,%{gcc_version},' %{SOURCE2} > rpm.doc/README.libgcjwebplugin.so

for i in {gcc,gcc/cp,gcc/java,gcc/ada,libstdc++-v3,libobjc,libmudflap,libgomp}/ChangeLog*; do
	cp -p $i rpm.doc/changelogs/$i
done

(cd gcc/fortran; for i in ChangeLog*; do
	cp -p $i ../../rpm.doc/gfortran/$i
done)
(cd libgfortran; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/gfortran/$i.libgfortran
done)
(cd gcc/objc; for i in README*; do
	cp -p $i ../../rpm.doc/objc/$i.objc
done)
(cd libobjc; for i in README*; do
	cp -p $i ../rpm.doc/objc/$i.libobjc
done)
(cd boehm-gc; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/boehm-gc/$i.gc
done)
(cd libffi; for i in ChangeLog* README* LICENSE; do
	cp -p $i ../rpm.doc/libffi/$i.libffi
done)
(cd libjava; for i in ChangeLog* README*; do
	cp -p $i ../rpm.doc/libjava/$i.libjava
done)
cp -p libjava/LIBGCJ_LICENSE rpm.doc/libjava/

rm -f rpm.doc/changelogs/gcc/ChangeLog.[1-9]
find rpm.doc -name \*ChangeLog\* | xargs bzip2 -9

%install
rm -fr $RPM_BUILD_ROOT

perl -pi -e \
  's~href="l(ibstdc|atest)~href="http://gcc.gnu.org/onlinedocs/libstdc++/l\1~' \
  libstdc++-v3/doc/html/documentation.html
ln -sf documentation.html libstdc++-v3/doc/html/index.html

cd obj-%{gcc_target_platform}

%if %{build_java}
export PATH=`pwd`/java_hacks${PATH:+:$PATH}
%endif

TARGET_PLATFORM=%{gcc_target_platform}

# There are some MP bugs in libstdc++ Makefiles
make -C %{gcc_target_platform}/libstdc++-v3

make prefix=$RPM_BUILD_ROOT%{_prefix} mandir=$RPM_BUILD_ROOT%{_mandir} \
  infodir=$RPM_BUILD_ROOT%{_infodir} install
%if %{build_java}
make DESTDIR=$RPM_BUILD_ROOT -C %{gcc_target_platform}/libjava install-src.zip
%endif
%if %{build_ada}
chmod 644 $RPM_BUILD_ROOT%{_infodir}/gnat*
%endif

FULLPATH=$RPM_BUILD_ROOT%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
FULLEPATH=$RPM_BUILD_ROOT%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}

# fix some things
ln -sf cpp%{bin_suffix} $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-cpp%{bin_suffix}
ln -sf gcc%{bin_suffix} $RPM_BUILD_ROOT%{_prefix}/bin/cc%{bin_suffix}
mkdir -p $RPM_BUILD_ROOT/lib
ln -sf ..%{_prefix}/bin/cpp%{bin_suffix} $RPM_BUILD_ROOT/lib/cpp%{bin_suffix}
ln -sf gfortran%{bin_suffix} $RPM_BUILD_ROOT%{_prefix}/bin/f95%{bin_suffix}

rm -f $RPM_BUILD_ROOT%{_infodir}/dir
%if "%{bin_suffix}" != ""
mv $RPM_BUILD_ROOT%{_infodir}/libgomp.info $RPM_BUILD_ROOT%{_infodir}/libgomp%{bin_suffix}.info
%endif
#gzip -9 $RPM_BUILD_ROOT%{_infodir}/*.info*

%if %{build_ada}
ln -sf gcc%{bin_suffix} $RPM_BUILD_ROOT%{_prefix}/bin/gnatgcc%{bin_suffix}
%endif

cxxconfig="`find %{gcc_target_platform}/libstdc++-v3/include -name c++config.h`"
for i in `find %{gcc_target_platform}/[36]*/libstdc++-v3/include -name c++config.h 2>/dev/null`; do
  if ! diff -up $cxxconfig $i; then
    cat > $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_version}/%{gcc_target_platform}/bits/c++config.h <<EOF
#ifndef _CPP_CPPCONFIG_WRAPPER
#define _CPP_CPPCONFIG_WRAPPER 1
#include <bits/wordsize.h>
#if __WORDSIZE == 32
%ifarch %{multilib_64_archs}
`cat $(find %{gcc_target_platform}/32/libstdc++-v3/include -name c++config.h)`
%else
`cat $(find %{gcc_target_platform}/libstdc++-v3/include -name c++config.h)`
%endif
#else
%ifarch %{multilib_64_archs}
`cat $(find %{gcc_target_platform}/libstdc++-v3/include -name c++config.h)`
%else
`cat $(find %{gcc_target_platform}/64/libstdc++-v3/include -name c++config.h)`
%endif
#endif
#endif
EOF
    break
  fi
done

# Nuke bits/stdc++.h.gch dirs
# 1) there is no bits/stdc++.h header installed, so when gch file can't be
#    used, compilation fails
# 2) sometimes it is hard to match the exact options used for building
#    libstdc++-v3 or they aren't desirable
# 3) there are multilib issues, conflicts etc. with this
# 4) it is huge
# People can always precompile on their own whatever they want, but
# shipping this for everybody is unnecessary.
rm -rf $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_version}/%{gcc_target_platform}/bits/stdc++.h.gch

%ifarch sparc sparc64
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-gcc%{bin_suffix} \
  $RPM_BUILD_ROOT%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-gcc%{bin_suffix}
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-g++%{bin_suffix} \
  $RPM_BUILD_ROOT%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-g++%{bin_suffix}
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-c++%{bin_suffix} \
  $RPM_BUILD_ROOT%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-c++%{bin_suffix}
%endif
%ifarch ppc ppc64
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-gcc%{bin_suffix} \
  $RPM_BUILD_ROOT%{_prefix}/bin/ppc-%{_vendor}-%{_target_os}-gcc%{bin_suffix}
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-c++%{bin_suffix} \
  $RPM_BUILD_ROOT%{_prefix}/bin/ppc-%{_vendor}-%{_target_os}-c++%{bin_suffix}
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-g++%{bin_suffix} \
  $RPM_BUILD_ROOT%{_prefix}/bin/ppc-%{_vendor}-%{_target_os}-g++%{bin_suffix}
%endif

%ifarch sparc ppc
FULLLPATH=$FULLPATH/lib32
%endif
%ifarch sparc64 ppc64
FULLLPATH=$FULLPATH/lib64
%endif
if [ -n "$FULLLPATH" ]; then
  mkdir -p $FULLLPATH
else
  FULLLPATH=$FULLPATH
fi

find $RPM_BUILD_ROOT -name \*.la | xargs rm -f
%if %{build_java}
# gcj -static doesn't work properly anyway, unless using --whole-archive
# and saving 35MB is not bad.
find $RPM_BUILD_ROOT -name libgcj.a -o -name libgtkpeer.a \
                     -o -name libgjsmalsa.a -o -name libgcj-tools.a -o -name libjvm.a \
                     -o -name libgij.a -o -name libgcj_bc.a | xargs rm -f

mv $RPM_BUILD_ROOT%{_prefix}/lib/libgcj.spec $FULLPATH/
sed -i -e 's/lib: /&%%{static:%%eJava programs cannot be linked statically}/' \
  $FULLPATH/libgcj.spec
%endif

mkdir -p $RPM_BUILD_ROOT/%{_lib}
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgcc_s.so.1 $RPM_BUILD_ROOT/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
chmod 755 $RPM_BUILD_ROOT/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
ln -sf libgcc_s-%{gcc_version}-%{DATE}.so.1 $RPM_BUILD_ROOT/%{_lib}/libgcc_s.so.1
ln -sf /%{_lib}/libgcc_s.so.1 $FULLPATH/libgcc_s.so
%ifarch sparc ppc
ln -sf /lib64/libgcc_s.so.1 $FULLPATH/64/libgcc_s.so
%endif
%ifarch %{multilib_64_archs}
ln -sf /lib/libgcc_s.so.1 $FULLPATH/32/libgcc_s.so
%endif

mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgomp.spec $FULLPATH/
#mv -f $RPM_BUILD_ROOT%{_prefix}/include/omp.h $FULLPATH/include/

pushd $RPM_BUILD_ROOT%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include-fixed
for x in *; do
case "$x" in
README|features.h|syslimits.h|limits.h) ;;
*) echo "remove included-fixed/$x"; rm -rf $x ;;
esac
done
popd


%if %{build_ada}
mv -f $FULLPATH/adalib/libgnarl-*.so $RPM_BUILD_ROOT%{_prefix}/%{_lib}/
mv -f $FULLPATH/adalib/libgnat-*.so $RPM_BUILD_ROOT%{_prefix}/%{_lib}/
rm -f $FULLPATH/adalib/libgnarl.so* $FULLPATH/adalib/libgnat.so*
%endif

mkdir -p $RPM_BUILD_ROOT%{_prefix}/libexec/getconf
if gcc/xgcc -B gcc/ -E -dD -xc /dev/null | grep __LONG_MAX__.*2147483647; then
  ln -sf POSIX_V6_ILP32_OFF32 $RPM_BUILD_ROOT%{_prefix}/libexec/getconf/default
else
  ln -sf POSIX_V6_LP64_OFF64 $RPM_BUILD_ROOT%{_prefix}/libexec/getconf/default
fi

%if %{build_java}
if [ "%{_lib}" != "lib" ]; then
  mkdir -p $RPM_BUILD_ROOT%{_prefix}/%{_lib}/pkgconfig	
  sed '/^libdir/s/lib$/%{_lib}/' $RPM_BUILD_ROOT%{_prefix}/lib/pkgconfig/libgcj-%{gcc_release}.pc \
      > $RPM_BUILD_ROOT%{_prefix}/%{_lib}/pkgconfig/libgcj-%{gcc_release}.pc
fi
%endif

pushd $FULLPATH
if [ "%{_lib}" = "lib" ]; then
ln -sf ../../../libobjc.so.2 libobjc.so
ln -sf ../../../libstdc++.so.6.* libstdc++.so
ln -sf ../../../libgfortran.so.3.* libgfortran.so
ln -sf ../../../libgomp.so.1.* libgomp.so
ln -sf ../../../libmudflap.so.0.* libmudflap.so
ln -sf ../../../libmudflapth.so.0.* libmudflapth.so
%if %{build_java}
ln -sf ../../../libgcj.so.9.* libgcj.so
ln -sf ../../../libgcj-tools.so.9.* libgcj-tools.so
ln -sf ../../../libgij.so.9.* libgij.so
%endif
%if %{build_ada}
cd adalib
ln -sf ../../../../libgnarl-*.so libgnarl.so
ln -sf ../../../../libgnarl-*.so libgnarl%{bin_suffix}.so
ln -sf ../../../../libgnat-*.so libgnat.so
ln -sf ../../../../libgnat-*.so libgnat%{bin_suffix}.so
cd ..
%endif
else
ln -sf ../../../../%{_lib}/libobjc.so.2 libobjc.so
ln -sf ../../../../%{_lib}/libstdc++.so.6.* libstdc++.so
ln -sf ../../../../%{_lib}/libgfortran.so.3.* libgfortran.so
ln -sf ../../../../%{_lib}/libgomp.so.1.* libgomp.so
ln -sf ../../../../%{_lib}/libmudflap.so.0.* libmudflap.so
ln -sf ../../../../%{_lib}/libmudflapth.so.0.* libmudflapth.so
%if %{build_java}
ln -sf ../../../../%{_lib}/libgcj.so.9.* libgcj.so
ln -sf ../../../../%{_lib}/libgcj-tools.so.9.* libgcj-tools.so
ln -sf ../../../../%{_lib}/libgij.so.9.* libgij.so
%endif
%if %{build_ada}
cd adalib
ln -sf ../../../../../%{_lib}/libgnarl-*.so libgnarl.so
ln -sf ../../../../../%{_lib}/libgnarl-*.so libgnarl%{bin_suffix}.so
ln -sf ../../../../../%{_lib}/libgnat-*.so libgnat.so
ln -sf ../../../../../%{_lib}/libgnat-*.so libgnat%{bin_suffix}.so
cd ..
%endif
fi
%if %{build_java}
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgcj_bc.so $FULLLPATH/
%endif
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libstdc++.*a $FULLLPATH/
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libsupc++.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgfortran.*a .
# mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgfortranbegin.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libobjc.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgomp.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libmudflap{,th}.*a .
#mv -f $RPM_BUILD_ROOT%{_prefix}/include/mf-runtime.h include/

%ifarch sparc ppc
ln -sf ../../../../../lib64/libobjc.so.2 64/libobjc.so
ln -sf ../`echo ../../../../lib/libstdc++.so.6.* | sed s~/lib/~/lib64/~` 64/libstdc++.so
ln -sf ../`echo ../../../../lib/libgfortran.so.3.* | sed s~/lib/~/lib64/~` 64/libgfortran.so
ln -sf ../`echo ../../../../lib/libgomp.so.1.* | sed s~/lib/~/lib64/~` 64/libgomp.so
ln -sf ../`echo ../../../../lib/libmudflap.so.0.* | sed s~/lib/~/lib64/~` 64/libmudflap.so
ln -sf ../`echo ../../../../lib/libmudflapth.so.0.* | sed s~/lib/~/lib64/~` 64/libmudflapth.so
%if %{build_java}
ln -sf ../`echo ../../../../lib/libgcj.so.9.* | sed s~/lib/~/lib64/~` 64/libgcj.so
ln -sf ../`echo ../../../../lib/libgcj-tools.so.9.* | sed s~/lib/~/lib64/~` 64/libgcj-tools.so
ln -sf ../`echo ../../../../lib/libgij.so.9.* | sed s~/lib/~/lib64/~` 64/libgij.so
ln -sf lib32/libgcj_bc.so libgcj_bc.so
ln -sf ../lib64/libgcj_bc.so 64/libgcj_bc.so
%endif
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libsupc++.*a 64/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libgfortran.*a 64/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libgfortranbegin.*a 64/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libobjc.*a 64/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libgomp.*a 64/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libmudflap{,th}.*a 64/
ln -sf lib32/libstdc++.a libstdc++.a
ln -sf ../lib64/libstdc++.a 64/libstdc++.a
%endif
%ifarch %{multilib_64_archs}
mkdir -p 32
ln -sf ../../../../libobjc.so.2 32/libobjc.so
ln -sf ../`echo ../../../../lib64/libstdc++.so.6.* | sed s~/../lib64/~/~` 32/libstdc++.so
ln -sf ../`echo ../../../../lib64/libgfortran.so.3.* | sed s~/../lib64/~/~` 32/libgfortran.so
ln -sf ../`echo ../../../../lib64/libgomp.so.1.* | sed s~/../lib64/~/~` 32/libgomp.so
ln -sf ../`echo ../../../../lib64/libmudflap.so.0.* | sed s~/../lib64/~/~` 32/libmudflap.so
ln -sf ../`echo ../../../../lib64/libmudflapth.so.0.* | sed s~/../lib64/~/~` 32/libmudflapth.so
%if %{build_java}
ln -sf ../`echo ../../../../lib64/libgcj.so.9.* | sed s~/../lib64/~/~` 32/libgcj.so
ln -sf ../`echo ../../../../lib64/libgcj-tools.so.9.* | sed s~/../lib64/~/~` 32/libgcj-tools.so
ln -sf ../`echo ../../../../lib64/libgij.so.9.* | sed s~/../lib64/~/~` 32/libgij.so
%endif
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libsupc++.*a 32/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libgfortran.*a 32/
#mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libgfortranbegin.*a 32/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libobjc.*a 32/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libgomp.*a 32/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libmudflap{,th}.*a 32/
%endif
%ifarch sparc64 ppc64
ln -sf ../lib32/libstdc++.a 32/libstdc++.a
ln -sf lib64/libstdc++.a libstdc++.a
%if %{build_java}
ln -sf ../lib32/libgcj_bc.so 32/libgcj_bc.so
ln -sf lib64/libgcj_bc.so libgcj_bc.so
%endif
%else
%ifarch %{multilib_64_archs}
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/libstdc++.a 32/libstdc++.a
%if %{build_java}
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/libgcj_bc.so 32/libgcj_bc.so
%endif
%endif
%endif

# Strip debug info from Fortran/ObjC/Java static libraries
strip -g `find . \( -name libgfortran.a -o -name libobjc.a -o -name libgomp.a \
		    -o -name libmudflap.a -o -name libmudflapth.a \
		    -o -name libgcc.a -o -name libgcov.a \) -a -type f`
popd
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgfortran.so.3.*
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgomp.so.1.*
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libmudflap{,th}.so.0.*
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libobjc.so.2.*

%if %{build_ada}
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgnarl*so*
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgnat*so*
%endif

for h in `find $FULLPATH/include -name \*.h`; do
  if grep -q 'It has been auto-edited by fixincludes from' $h; then
    rh=`grep -A2 'It has been auto-edited by fixincludes from' $h | tail -1 | sed 's|^.*"\(.*\)".*$|\1|'`
    diff -up $rh $h || :
    rm -f $h
  fi
done

%if "%{bin_suffix}" == ""
install -m755 %{SOURCE8000} %{buildroot}/%{_prefix}/bin/c89
install -m755 %{SOURCE8001} %{buildroot}/%{_prefix}/bin/c99
%endif

mkdir -p $RPM_BUILD_ROOT%{_prefix}/sbin
gcc -static -Os %{SOURCE1} -o $RPM_BUILD_ROOT%{_prefix}/sbin/libgcc_post_upgrade
strip $RPM_BUILD_ROOT%{_prefix}/sbin/libgcc_post_upgrade

cd ..
%find_lang gcc%{bin_suffix}
%find_lang cpplib%{bin_suffix}

# Remove binaries we will not be including, so that they don't end up in
# gcc-debuginfo
rm -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libiberty.a
rm -f $FULLEPATH/install-tools/{mkheaders,fixincl}
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/{32,64}/libiberty.a
rm -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libssp*
rm -f $RPM_BUILD_ROOT%{_prefix}/bin/gnative2ascii

%ifarch %{multilib_64_archs}
# Remove libraries for the other arch on multilib arches
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/lib*.so*
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/lib*.a
%else
%ifarch sparc ppc
rm -f $RPM_BUILD_ROOT%{_prefix}/lib64/lib*.so*
rm -f $RPM_BUILD_ROOT%{_prefix}/lib64/lib*.a
%endif
%endif

%if %{build_java}
mkdir -p $RPM_BUILD_ROOT%{_prefix}/share/java/gcj-endorsed \
	 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/gcj-%{version}/classmap.db.d
chmod 755 $RPM_BUILD_ROOT%{_prefix}/share/java/gcj-endorsed \
	  $RPM_BUILD_ROOT%{_prefix}/%{_lib}/gcj-%{version} \
	  $RPM_BUILD_ROOT%{_prefix}/%{_lib}/gcj-%{version}/classmap.db.d
touch $RPM_BUILD_ROOT%{_prefix}/%{_lib}/gcj-%{version}/classmap.db
ln -sf ../libgcj.so.9 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/gcj-%{version}/libgcj_bc.so.1
%endif

install -m644 %{SOURCE3} $RPM_BUILD_ROOT%{_mandir}/man1/protoize%{bin_suffix}.1
echo '.so man1/protoize.1' > $RPM_BUILD_ROOT%{_mandir}/man1/unprotoize%{bin_suffix}.1
chmod 644 $RPM_BUILD_ROOT%{_mandir}/man1/unprotoize%{bin_suffix}.1

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gcc%{bin_suffix}.info || :
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gccint%{bin_suffix}.info || :
[ -x %{_sbindir}/update-ccache.sh ] && %{_sbindir}/update-ccache.sh || :

%preun
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gcc%{bin_suffix}.info || :
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gccint%{bin_suffix}.info || :
fi

%postun
[ -x %{_sbindir}/update-ccache.sh ] && %{_sbindir}/update-ccache.sh || :

%post c++
[ -x %{_sbindir}/update-ccache.sh ] && %{_sbindir}/update-ccache.sh || :

%postun c++
[ -x %{_sbindir}/update-ccache.sh ] && %{_sbindir}/update-ccache.sh || :

%post -n cpp%{pkg_suffix}
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/cpp%{bin_suffix}.info || :
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/cppinternals%{bin_suffix}.info || :

%preun -n cpp%{pkg_suffix}
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/cpp%{bin_suffix}.info || :
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/cppinternals%{bin_suffix}.info || :
fi

%post gfortran
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gfortran%{bin_suffix}.info || :

%preun gfortran
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gfortran%{bin_suffix}.info || :
fi

%if %{build_java}
%post java
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gcj%{bin_suffix}.info || :

%preun java
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gcj%{bin_suffix}.info || :
fi
%endif

%post gnat
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gnat_rm%{bin_suffix}.info || :
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gnat_ugn_unw%{bin_suffix}.info || :
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gnat-style%{bin_suffix}.info || :

%preun gnat
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gnat_rm%{bin_suffix}.info || :
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gnat_ugn_unw%{bin_suffix}.info || :
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gnat-style%{bin_suffix}.info || :
fi

%post -n libgomp%{pkg_suffix}
/sbin/ldconfig
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/libgomp%{bin_suffix}.info || :

%postun -n libgomp%{pkg_suffix}
/sbin/ldconfig

%preun -n libgomp%{pkg_suffix}
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/libgomp%{bin_suffix}.info || :
fi

# Because glibc Prereq's libgcc and /sbin/ldconfig
# comes from glibc, it might not exist yet when
# libgcc is installed
%post -n libgcc%{pkg_suffix} -p %{_prefix}/sbin/libgcc_post_upgrade

%postun -n libgcc%{pkg_suffix}
/sbin/ldconfig

%post -n libstdc++%{pkg_suffix}
/sbin/ldconfig

%postun -n libstdc++%{pkg_suffix}
/sbin/ldconfig

%post -n libobjc%{pkg_suffix}
/sbin/ldconfig

%postun -n libobjc%{pkg_suffix}
/sbin/ldconfig

%if %{build_java}
%post -n libgcj%{pkg_suffix}
/sbin/ldconfig

%postun -n libgcj%{pkg_suffix}
/sbin/ldconfig

%post -n libgcj%{pkg_suffix}-devel
/sbin/ldconfig

%postun -n libgcj%{pkg_suffix}-devel
/sbin/ldconfig
%endif

%post -n libgfortran%{pkg_suffix}
/sbin/ldconfig

%postun -n libgfortran%{pkg_suffix}
/sbin/ldconfig

%post -n libgnat%{pkg_suffix}
/sbin/ldconfig

%postun -n libgnat%{pkg_suffix}
/sbin/ldconfig

%post -n libmudflap%{pkg_suffix}
/sbin/ldconfig

%postun -n libmudflap%{pkg_suffix}
/sbin/ldconfig

%files -f gcc%{bin_suffix}.lang
%defattr(-,root,root)
%{_prefix}/bin/cc%{bin_suffix}
%if "%{bin_suffix}" == ""
%{_prefix}/bin/c89
%{_prefix}/bin/c99
%endif
%{_prefix}/bin/gcc%{bin_suffix}
%{_prefix}/bin/gccbug%{bin_suffix}
%{_prefix}/bin/gcov%{bin_suffix}
%{_prefix}/bin/protoize%{bin_suffix}
%{_prefix}/bin/unprotoize%{bin_suffix}
%ifarch sparc ppc
%{_prefix}/bin/%{_target_platform}-gcc%{bin_suffix}
%endif
%ifarch sparc64
%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-gcc%{bin_suffix}
%endif
%ifarch ppc64
%{_prefix}/bin/ppc-%{_vendor}-%{_target_os}-gcc%{bin_suffix}
%endif
%{_prefix}/bin/%{gcc_target_platform}-gcc%{bin_suffix}
%{_prefix}/bin/%{gcc_target_platform}-gcc-%{version}
%{_mandir}/man1/gcc%{bin_suffix}.1*
%{_mandir}/man1/gcov%{bin_suffix}.1*
%{_mandir}/man1/protoize%{bin_suffix}.1*
%{_mandir}/man1/unprotoize%{bin_suffix}.1*
%{_infodir}/gcc*
%if "%{bin_suffix}" == ""
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%endif
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include-fixed
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include-fixed/*.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include-fixed/README
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/SYSCALLS.c.X
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stddef.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stdarg.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/varargs.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/float.h
#%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/limits.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stdbool.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/iso646.h
#%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/syslimits.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/unwind.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/omp.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stdfix.h
%ifarch %{ix86} x86_64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/xmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/emmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/pmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/tmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ammintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/smmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/nmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/bmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/wmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mmintrin-common.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mm_malloc.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mm3dnow.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/cpuid.h
%endif
%ifarch ia64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ia64intrin.h
%endif
%ifarch ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ppc-asm.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/altivec.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/spe.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/paired.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ppu_intrinsics.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/si2vmx.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/spu2vmx.h
%endif
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/collect2
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcov.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_s.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgomp.spec
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgomp.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgomp.so
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcov.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcc_s.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgomp.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgomp.so
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcov.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcc_s.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgomp.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgomp.so
%endif
#%{_prefix}/libexec/getconf/default
%doc gcc/README* rpm.doc/changelogs/gcc/ChangeLog* gcc/COPYING*

%files -n cpp%{pkg_suffix} -f cpplib%{bin_suffix}.lang
%defattr(-,root,root)
/lib/cpp%{bin_suffix}
%{_prefix}/bin/cpp%{bin_suffix}
%{_prefix}/bin/%{gcc_target_platform}-cpp%{bin_suffix}
%{_mandir}/man1/cpp%{bin_suffix}.1*
%{_infodir}/cpp*
%if "%{bin_suffix}" == ""
%dir %{_prefix}/libexec/gcc
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}
%endif
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/cc1

%files -n libgcc%{pkg_suffix}
%defattr(-,root,root)
/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
/%{_lib}/libgcc_s.so.1
%{_prefix}/sbin/libgcc_post_upgrade
%doc gcc/COPYING.LIB

%files c++
%defattr(-,root,root)
%{_prefix}/bin/%{gcc_target_platform}-*++%{bin_suffix}
%{_prefix}/bin/g++%{bin_suffix}
%{_prefix}/bin/c++%{bin_suffix}
%ifarch sparc ppc
%{_prefix}/bin/%{_target_platform}-*++%{bin_suffix}
%endif
%ifarch sparc64
%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-*++%{bin_suffix}
%endif
%ifarch ppc64
%{_prefix}/bin/ppc-%{_vendor}-%{_target_os}-*++%{bin_suffix}
%endif
%{_mandir}/man1/g++%{bin_suffix}.1*
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/cc1plus
%ifarch sparc ppc
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libsupc++.a
%endif
%ifarch %{multilib_64_archs}
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libsupc++.a
%endif
%ifarch sparc ppc %{multilib_64_archs}
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libsupc++.a
%endif
%ifarch sparc sparc64 ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.a
%endif
%doc rpm.doc/changelogs/gcc/cp/ChangeLog*

%files -n libstdc++%{pkg_suffix}
%defattr(-,root,root)
%{_prefix}/%{_lib}/libstdc++.so.6*[^so]
%{_datadir}/locale/*/LC_MESSAGES/libstdc++.mo

%files -n libstdc++%{pkg_suffix}-devel
%defattr(-,root,root)
%if "%{bin_suffix}" == ""
%dir %{_prefix}/include/c++
%endif
%dir %{_prefix}/include/c++/%{gcc_version}
%{_prefix}/include/c++/%{gcc_version}/[^gj]*
%ifarch sparc ppc
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/libstdc++.a
%endif
%ifarch sparc64 ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64/libstdc++.a
%endif
%ifnarch sparc sparc64 ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.a
%endif
%ifnarch sparc ppc %{multilib_64_archs}
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libsupc++.a
%endif
%doc rpm.doc/changelogs/libstdc++-v3/ChangeLog* libstdc++-v3/README* libstdc++-v3/doc/html/

%files objc
%defattr(-,root,root)
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/objc
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/cc1obj
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libobjc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libobjc.so
%ifarch sparc ppc
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libobjc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libobjc.so
%endif
%ifarch %{multilib_64_archs}
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libobjc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libobjc.so
%endif
%doc rpm.doc/objc/*
%doc libobjc/THREADS* rpm.doc/changelogs/libobjc/ChangeLog*

%files objc++
%defattr(-,root,root)
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/cc1objplus

%files -n libobjc%{pkg_suffix}
%defattr(-,root,root)
%{_prefix}/%{_lib}/libobjc.so.2*

%files gfortran
%defattr(-,root,root)
%{_prefix}/bin/gfortran%{bin_suffix}
%{_prefix}/bin/%{gcc_target_platform}-gfortran%{bin_suffix}
%{_prefix}/bin/f95%{bin_suffix}
%{_mandir}/man1/gfortran%{bin_suffix}.1*
%{_infodir}/gfortran*
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/finclude
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/finclude/omp_lib.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/finclude/omp_lib.f90
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/finclude/omp_lib.mod
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/finclude/omp_lib_kinds.mod
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/f951
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgfortranbegin.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgfortran.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgfortran.so
%ifarch sparc ppc
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgfortranbegin.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgfortran.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgfortran.so
%endif
%ifarch %{multilib_64_archs}
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgfortranbegin.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgfortran.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgfortran.so
%endif
%doc rpm.doc/gfortran/*

%files -n libgfortran%{pkg_suffix}
%defattr(-,root,root)
%{_prefix}/%{_lib}/libgfortran.so.3*

%if %{build_java}
%files java
%defattr(-,root,root)
%{_prefix}/bin/gcj%{bin_suffix}
%{_prefix}/bin/%{gcc_target_platform}-gcj%{bin_suffix}
%{_prefix}/bin/gjavah%{bin_suffix}
#%{_prefix}/bin/%{gcc_target_platform}-gcjh%{bin_suffix}
%{_prefix}/bin/gcjh%{bin_suffix}
%{_prefix}/bin/jcf-dump%{bin_suffix}
#%{_prefix}/bin/gjnih%{bin_suffix}
#%{_prefix}/bin/jv-scan%{bin_suffix}
%{_mandir}/man1/gcj%{bin_suffix}.1*
%{_mandir}/man1/gcjh%{bin_suffix}.1*
#%{_mandir}/man1/gjnih%{bin_suffix}.1*
%{_mandir}/man1/gjavah%{bin_suffix}.1*
%{_mandir}/man1/jcf-dump%{bin_suffix}.1*
#%{_mandir}/man1/jv-scan%{bin_suffix}.1*
%{_infodir}/gcj*
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/jc1
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/ecj1
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/jvgenmain
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcj.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcj-tools.so
%if "%{bin_suffix}" == ""
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcj_bc.so
%endif
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgij.so
%ifarch sparc ppc
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcj.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcj-tools.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcj_bc.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgij.so
%endif
%ifarch %{multilib_64_archs}
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcj.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcj-tools.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcj_bc.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgij.so
%endif
%doc rpm.doc/changelogs/gcc/java/ChangeLog*

%files -n libgcj%{pkg_suffix}
%defattr(-,root,root)
%{_prefix}/bin/jv-convert%{bin_suffix}
%{_prefix}/bin/gij%{bin_suffix}
%{_prefix}/bin/gjar%{bin_suffix}
# %{_prefix}/bin/fastjar%{bin_suffix}
# %{_prefix}/bin/grepjar%{bin_suffix}
%{_prefix}/bin/grmic%{bin_suffix}
%{_prefix}/bin/grmid%{bin_suffix}
%{_prefix}/bin/grmiregistry%{bin_suffix}
%{_prefix}/bin/gtnameserv%{bin_suffix}
%{_prefix}/bin/gkeytool%{bin_suffix}
%{_prefix}/bin/gorbd%{bin_suffix}
%{_prefix}/bin/gserialver%{bin_suffix}
%{_prefix}/bin/gcj-dbtool%{bin_suffix}
%{_prefix}/bin/gc-analyze%{bin_suffix}
%if %{include_gappletviewer}
%{_prefix}/bin/gappletviewer%{bin_suffix}
%endif
%{_prefix}/bin/gjarsigner%{bin_suffix}
# %{_mandir}/man1/fastjar%{bin_suffix}.1*
# %{_mandir}/man1/grepjar%{bin_suffix}.1*
%{_mandir}/man1/gjar%{bin_suffix}.1*
%{_mandir}/man1/gjarsigner%{bin_suffix}.1*
%{_mandir}/man1/jv-convert%{bin_suffix}.1*
%{_mandir}/man1/gij%{bin_suffix}.1*
%{_mandir}/man1/grmic%{bin_suffix}.1*
%{_mandir}/man1/grmiregistry%{bin_suffix}.1*
%{_mandir}/man1/gcj-dbtool%{bin_suffix}.1*
%{_mandir}/man1/gkeytool%{bin_suffix}.1*
%{_mandir}/man1/gorbd%{bin_suffix}.1*
%{_mandir}/man1/grmid%{bin_suffix}.1*
%{_mandir}/man1/gserialver%{bin_suffix}.1*
%{_mandir}/man1/gtnameserv%{bin_suffix}.1*
%if %{include_gappletviewer}
%{_mandir}/man1/gappletviewer%{bin_suffix}.1*
%endif
%{_mandir}/man1/gc-analyze%{bin_suffix}.1*
%{_mandir}/man1/gnative2ascii%{bin_suffix}.1*
# %{_infodir}/fastjar*
%{_prefix}/%{_lib}/libgcj.so.*
%{_prefix}/%{_lib}/libgcj-tools.so.*
%{_prefix}/%{_lib}/libgcj_bc.so.*
%{_prefix}/%{_lib}/libgij.so.*
%dir %{_prefix}/%{_lib}/gcj-%{version}
%{_prefix}/%{_lib}/gcj-%{version}/libgtkpeer.so
%{_prefix}/%{_lib}/gcj-%{version}/libgjsmalsa.so
%{_prefix}/%{_lib}/gcj-%{version}/libjawt.so
%{_prefix}/%{_lib}/gcj-%{version}/libgcj_bc.so*
%if %{include_gappletviewer}
%{_prefix}/%{_lib}/gcj-%{version}/libgcjwebplugin.so
%endif
%{_prefix}/%{_lib}/gcj-%{version}/libjvm.so
#%{_prefix}/share/java/[^s]*
%{_prefix}/share/java/libgcj-%{version}.jar
%if "%{bin_suffix}" == ""
%dir %{_prefix}/%{_lib}/security
%config(noreplace) %{_prefix}/%{_lib}/security/classpath.security
%{_prefix}/%{_lib}/logging.properties
%endif
%dir %{_prefix}/%{_lib}/gcj-%{version}/classmap.db.d
%attr(0644,root,root) %verify(not md5 size mtime) %ghost %config(missingok,noreplace) %{_prefix}/%{_lib}/gcj-%{version}/classmap.db
%if %{include_gappletviewer}
%doc rpm.doc/README.libgcjwebplugin.so
%endif

%files -n libgcj%{pkg_suffix}-devel
%defattr(-,root,root)
%{_prefix}/bin/addr2name.awk%{bin_suffix}
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/gcj
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/jawt.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/jawt_md.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/jni.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/jni_md.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/jvmpi.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcj.spec
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/libgcj_bc.so
%endif
%ifarch sparc64 ppc64
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64/libgcj_bc.so
%endif
%{_prefix}/include/c++/%{gcc_version}/[gj]*
%{_prefix}/%{_lib}/pkgconfig/libgcj*.pc
%doc rpm.doc/boehm-gc/*
%doc rpm.doc/libjava/*
%endif

%if %{build_java}
%files -n libgcj%{pkg_suffix}-src
%defattr(-,root,root)
%{_prefix}/share/java/src*.zip
%{_prefix}/share/java/libgcj-tools-%{version}.jar
%endif

%if %{build_ada}
%files gnat
%defattr(-,root,root)
%{_prefix}/bin/gnat*%{bin_suffix}
%{_prefix}/bin/gpr*%{bin_suffix}
%{_infodir}/gnat*
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/adainclude
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/adalib
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/gnat1
%doc rpm.doc/changelogs/gcc/ada/ChangeLog*

%files -n libgnat%{pkg_suffix}
%defattr(-,root,root)
%{_prefix}/%{_lib}/libgnat-*.so
%{_prefix}/%{_lib}/libgnarl-*.so
%endif

%files -n libgomp%{pkg_suffix}
%defattr(-,root,root)
%{_prefix}/%{_lib}/libgomp.so.1*
%doc rpm.doc/changelogs/libgomp/ChangeLog*
%{_infodir}/libgomp*

%files -n libmudflap%{pkg_suffix}
%defattr(-,root,root)
%{_prefix}/%{_lib}/libmudflap.so.0*
%{_prefix}/%{_lib}/libmudflapth.so.0*

%files -n libmudflap%{pkg_suffix}-devel
%defattr(-,root,root)
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mf-runtime.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflap.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflapth.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflap.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflapth.so
%ifarch sparc ppc
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libmudflap.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libmudflapth.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libmudflap.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libmudflapth.so
%endif
%ifarch %{multilib_64_archs}
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libmudflap.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libmudflapth.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libmudflap.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libmudflapth.so
%endif
%doc rpm.doc/changelogs/libmudflap/ChangeLog*

%files -n libffi
%defattr(-,root,root)
%{_prefix}/%{_lib}/libffi.so*

%files -n libffi-devel
%defattr(-,root,root)
%{_prefix}/%{_lib}/libffi.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ffi.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ffitarget.h
%doc rpm.doc/libffi/*

%changelog
* Mon Jul 13 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (4.3.3-10m)
- add Requires(post,preun,postun)
- remove unnecessary fastjar stuff, breaks build (bash40 issue)

* Sun Jul  5 2009 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.3-9m)
- "install-info --delete" should be in %%preun

* Sun Jul  5 2009 Nishio Futoshi <futoshi@momonga-linux.org>
- (4.3.3-8m)
- add Requires(post): info to libgomp

* Sat Jun 20 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (4.3.3-7m)
- rebuild against xulrunner-1.9.1

* Tue May  5 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (4.3.3-6m)
- BuildRequires: /usr/share/java/eclipse-ecj.jar if %%{build_java}

* Sat May  2 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.3-5m)
- update to gcc-4.3-20090501 (r147026)
-- PR fortran/39791
-- PR target/39496
-- PR target/39740
-- PR target/39634
-- PR testsuite/39769
-- PR c++/38228
-- PR c++/39639
-- PR c++/39480
-- PR c++/28301
-- PR c++/39637
-- PR c++/35146
-- PR bootstrap/39739

* Sat Apr 11 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.3-4m)
- update to gcc-4.3-20090406 (r145576)
-- PR objc/27377
-- PR rtl-optimization/39588
-- PR target/39175
-- PR target/39482
-- PR libfortran/39528
-- PR fortran/39519
-- PR objc/18456
-- PR objc/27377
-- PR c++/38030, 38850, 39070

* Fri Mar 20 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (4.3.3-3m)
- update to gcc-4.3-20090319 (r144971)
-- PR c++/9634,29469,29607,38950,39070,39225,39425
-- PR c/35444,35446
-- PR fortran/38852,39006,39292,39295
-- PR inline-asm/39058
-- PR libstdc++/39405
-- PR middle-end/36578,37861
-- PR rtl-optimization/39241
-- PR target/38056,39228,39327,39477
-- PR testsuite/39451
- License: GPLv3+ and "GPLv2+ with exceptions"

* Wed Feb 25 2009 TABUCHI Takaaki <tab@momonga-linux.org>
- (4.3.3-2m)
- add BuildRequires: /lib/libc.so.6 /usr/lib/libc.so /lib64/libc.so.6 /usr/lib64/libc.so
  for fix multilib_64_archs build

* Fri Feb 13 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.3-1m)
- update 4.3.3-20090212

* Wed Jan 21 2009 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.3.2-9m)
- set --with-pkgversion="Momonga Linux 6"

* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (4.3.2-8m)
- rebuild against rpm-4.6

* Sat Jan 17 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (4.3.2-7m)
- %%global _default_patch_fuzz 2

* Thu Dec 25 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.2-6m)
- update 20081223
- fix many PRs
-- bootstrap:  33100, 38383
-- c++      :  37142, 35405, 37563, 37582
-- libstdc++:  37144, 38080
-- fortran:    38602, 38487, 38113, 35983, 35937, 34820, 34143, 32795
--             38033, 37926, 37792, 35681, 38171, 37735, 36526 
-- libfortran: 38135
-- target:     38402, 38254, 38287, 38054, 37640, 38062
-- middle-end: 38565
-- testsuite:  35677, 28870
-- tree-optimization:38478, 37868
-- other:      38214

* Mon Nov 17 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.2-5m)
- update 20081116

* Wed Oct 15 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.2-4m)
- add gcc43-pr29609-2.patch, gcc43-pr29609-3.patch

* Thu Oct  9 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.2-3m)
- update 20081008

* Thu Sep 18 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.2-2m)
- import Fedora patch.(gcc-4.3.2-3)
- BPR mpfr-3.3.2
- merge gcc-4.3.2-rh-r140410.patch

* Fri Sep  5 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.2-1m)
- import gcc-test branch changes
- import Fedora patch.(gcc-4.3.2-1)
- add 4.3_stable patch(r139965)
-- PR c/37261, c++/37348, target/36332, target/37168
--    fortran/37193, fortran/36371, middle-end/37248
--    middle-end/36449

* Wed Jul 30 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.1-7m)
- import Fedora patch.(gcc-4.3.1-5)
- add PR c++/36852 patch

* Sun Jul 27 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.1-6m)
- update gcc-4.3-20080727(r138187)
- add bootstrap_gcj flag

* Wed Jul  9 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.1-5m)
- merge fedora gcc-4.3-4

* Sun Jul  6 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.1-4m)
- update gcc-4.3-20080704 upstream patch
- use eclipse-ecj-3.3.2.jar

* Fri Jun 27 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.1-3m)
- merge from fedora gcc-4.3.1-3
- update gcc-4.3-20080626 upstream patch

* Tue Jun 17 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.1-2m)
- merge from fedora gcc-4.3.1-2
- update gcc-4.3-20080616 upstream patch

* Tue Jun 10 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.1-1m)
- merge from fedora gcc-4.3.1

* Thu May 29 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.0-16m)
- merge from gcc-4.3-branch(20080529)

* Mon May 19 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.0-15m)
- merge from gcc-4.3-branch(20080519)

* Tue Apr 29 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (4.3.0-14m)
- rebuild against firefox-3
- add BuildRequires: xulrunner-devel

* Tue Apr 29 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.0-13m)
- import fedora patches
-  * Mon Apr 28 2008 Jakub Jelinek <jakub@redhat.com> 4.3.0-8
- - update from gcc-4_3-branch
- - decrease compile time stack usage during GC (#443739, PR debug/36060)
- - fix -mregparm=X with K&R function decls (#443583, PR target/36015)
- - fix tail called sqrt and math builtins (#435297,
-   PR rtl-optimization/36017)
- - PRs c++/33486, c++/35316, c++/35325, c++/35678, c++/35747, c++/35758,
-   c++/35773, c/35436, c/35744, fortran/35932, fortran/35944,
-   fortran/35946, fortran/35947, fortran/35959, fortran/35994,
-   libgcj/35950, libstdc++/35597, libstdc++/35887, libstdc++/35954,
-   middle-end/36021, target/35944, testsuite/36056,
-   tree-optimization/35982, tree-optimization/36008,
-   tree-optimization/36034
- - fix C++ const references to bitfields (PR c++/35909)
- - fix C++ ++var = val error recovery (PR c++/35987)
- - fix C++ reference binding to function through using-decl (PR c++/35650)

* Thu Apr 17 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (4.3.0-12m)
- delete BuildRequires: firefox-devel

* Thu Apr 17 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.0-11m)
- fortran Req mpfr-devel
- import fedora patches
- * Wed Apr 16 2008 Jakub Jelinek <jakub@redhat.com> 4.3.0-7
- - update from gcc-4_3-branch
- - PRs c++/35708, c++/35734, libstdc++/35816, middle-end/35519,
-       rtl-optimization/34916, target/35364, target/35695,
-       tree-optimization/35821, tree-optimization/35833
- - fix libgfortran buffer overflows
- - fix restoring of Altivec registers when alloca is used (PR target/35907)
- - misc fixes (PRs tree-optimization/35899, target/35662, c/35739)

* Sat Apr  5 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.0-10m)
- import fedora patches
- * Fri Apr  4 2008 Jakub Jelinek <jakub@redhat.com> 4.3.0-6
- - update from gcc-4_3-branch
-   - PRs ada/33857, c++/35245, c++/35741, c/35738, fortran/35698,
- 	fortran/35699, fortran/35702, fortran/35724, fortran/35740,
- 	fortran/35786, libfortran/35699, libstdc++/35725, middle-end/35429,
- 	middle-end/35705, middle-end/35818, target/31110, target/31232,
- 	target/35657, tree-opt/35431
- - fix OpenMP ICE on invalid extern/static VLA (PR c/35751)
- - fix PCH failure if a precompiled header is included more than
-   once (#251682, PR pch/13675)

* Wed Apr  2 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-9m)
- copy from branches/TSUPPA4RI/gcc r23138

* Mon Mar 31 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-8m)
- add BuildRequires: fastjar

* Sun Mar 30 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-7m)
- fix x86_64 support, again

* Sun Mar 30 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-6m)
- fix x86_64 support

* Sat Mar 29 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-5m)
- fix libgcj_bc.so issue
- cleanup spec

* Fri Mar 28 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-4m)
- update to 4.3.0 
-- merge from T4R/gcc-test/gcc43 r23069
-- disable alternatives support
-- remove bin_suffix and pkg_suffix
-- fix some %%{bin_suffix} issues
- revise spec
-- now *info are compressed by bzip2

* Fri Mar 28 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.0-3m)
- import fedora patch
- * Thu Mar 27 2008 Jakub Jelinek <jakub@redhat.com> 4.3.0-5
- - fix libgomp when sync builtins aren't available
- - on i386 build libgomp and __cxa_guard_* as i486+,
-   NPTL doesn't support pre-i486 anyway and atomic builtins give
-   significant speedups
- 
- * Wed Mar 26 2008 Jakub Jelinek <jakub@redhat.com> 4.3.0-4
- - update from gcc-4_3-branch
-   - PRs c++/35332, c++/35548, debug/31510, fortran/33295, fortran/34813,
- 	libfortran/35617, libfortran/35627, libgomp/35625, libstdc++/35256,
- 	libstdc++/35637, middle-end/35593, middle-end/35609,
- 	middle-end/35611, middle-end/35616, target/35504, testsuite/34168,
- 	testsuite/35621
- - backport libgomp speedups from gomp-3_0-branch (#437268)
- - fix diagnostics with compound literals (PR c/35440)
- - fix C++ handling of late template attributes (PR c++/35546)
- - Prereq install-info in libgomp (#437523)

* Fri Mar 21 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.0-2m)
- import fedora patch

* Fri Mar  7 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.0-1m)
- update to 4.3.0-release

* Sat Mar  1 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.25m)
- update to snapshots/4.3-20080228

* Fri Feb 22 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.0-0.24m)
- update to snapshots/4.3-20080221

* Tue Feb 19 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.23m)
- add update-ccache.sh in %%post and %%postun

* Fri Feb 15 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.22m)
- update to snapshots/4.3-20080215

* Sat Feb  9 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.21m)
- import ia64 support patches from fc-devel

* Sat Feb  9 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.20m)
- update to snapshots/4.3-20080208

* Fri Jan 25 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.18m)
- update to snapshots/4.3-20080125
- update gcc43-rename-info.patch 
- delete gcc43-fix-protoize.patch

* Thu Jan 17 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.17m)
- updated to snapshots/4.3-20080118
- added libffi sub-package
- deleted gcc43-adhoc.patch
- revised libgcc sub-package

* Thu Jan 10 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.16m)
- updated to snapshots/4.3-20080111

* Fri Jan  4 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.15m)
- updated to snapshots/4.3-20080104
- revised %%files section
- deleted OPT_FLAGS hack

* Fri Dec 21 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.14m)
- updated to snapshots/4.3-20071221

* Sat Dec 15 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.13m)
- updated to snapshots/4.3-20071214
- deleted REMOVE.PLEASE
- imported two patches from fc-devel (gcc-4_3_0-0_3)
-- gcc43-build-id.patch
-- gcc43-c++-builtin-redecl.patch

* Sat Dec  8 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.12m)
- updated to snapshots/4.3-20071207

* Thu Nov 29 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.11m)
- updated to snapshots/4.3-20071130
- fixed alternatives support
- added all *.h in %%{_prefix}/lib/gcc/%%{gcc_target_platform}/
- added gc-analyze and gnative2ascii to libgcj
- added "Require:" for libgomp, libobc and libmudflap

* Sat Nov 24 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.10m)
- updated to snapshots/4.3-20071123
- added --with-pkgversion
- revised alternatives support again

* Wed Nov 21 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.9m)
- revised alternatives support again

* Thu Nov 15 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.8m)
- updated to snapshots/4.3-20071116
- added header files generated by fixincludes
- fixed alternatives

* Sat Nov 10 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.7m)
- updated to snapshots/4.3-20071109

* Sat Nov  3 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.6m)
- updated to snapshots/4.3-20071102

* Wed Oct 24 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.5m)
- updated to snapshots/4.3-20071026
- changed BOOT_CFLAGS to fix bootstrap failure
- added gcc43-fix-protoize.patch
- updated gcc43-rename-info.patch

* Sat Oct 20 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.4m)
- updated to snapshots/4.3-20071019

* Thu Oct 18 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.3m)
- added gcc43-adhoc.patch
- added REMOVE.PLEASE so that gcj won't be built with installed ecj1

* Wed Oct 17 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.2m)
- fixed gcj
-- updated gcc43-fix-gcj.patch
-- added %%{_prefix}/%%{_lib}/gcj-%%{version}/libgcj_bc.so.1 for ecj1

* Sat Oct 13 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-0.1m)
- inital import for GCC's 4.3 branch
